# Installation procedure ripped from GRUF 
# my thanks goes to PJ Grizel

from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Acquisition import aq_base

from Products.PloneCASLogin import install_globals

SKIN_NAME='PloneCASLogin'
_globals = install_globals

def install(self):
    out = StringIO()
    print >>out, "Installing PloneCASLogin"
    install_subskin(self, out)
    print >>out, "Done."
    return out.getvalue()

def install_subskin(self, out, skin_name=SKIN_NAME, globals=_globals):
    print >>out, "  Installing subskin."
    skinstool=getToolByName(self, 'portal_skins')
    if skin_name not in skinstool.objectIds():
        print >>out, "    Adding directory view for PloneCASLogin"
        addDirectoryViews(skinstool, 'skins', globals)

    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName)
        path = [i.strip() for i in  path.split(',')]
        try:
            if skin_name not in path:
                path.insert(path.index('custom') +1, skin_name)
        except ValueError:
            if skin_name not in path:
                path.append(skin_name)

        path = ','.join(path)
        skinstool.addSkinSelection( skinName, path)
    print >>out, "  Done installing subskin."

