## Script (Python) "cas_get_urls"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Get ACASUserFolder URL's
##

#
# This code try hard to contact the 1st ACASUserFolder found in the current 
# Plone site
# Currently supports GroupUserFolder 3.1->3.3 and maybe other versions.
# 
# Returns :
#  - None if no ACAS User Folder found 
#  - a dict with the keys : login_url validate_url logout_url
#

self = container

while self is not None:
  try:
    if hasattr(self, 'objectValues'):
        for o in self.objectValues():
	    if (hasattr(o, 'id') and o.id == 'acl_users' and hasattr(o, 'meta_type')):
		if (o.meta_type == 'Group User Folder'):
		    try:
		        for src in o.objectValues(['GRUFUsers']):
			    if 'acl_users' in src.objectIds() and src.acl_users.meta_type == 'ACAS User Folder':
			        o = src.acl_users
				break
		    except: pass
		
		if (o.meta_type == 'ACAS User Folder'):
		    return { 'login_url'    : o.cuf_login_url,
		             'validate_url' : o.cuf_validate_url,
		             'logout_url'   : o.cuf_logout_url,   
			   }
  except: pass
	    
  # goes up one level and may search upper than the Plone Site
  if hasattr(self, 'aq_parent') and hasattr(self, 'meta_type'):
      self = self.aq_parent
  else: 
      self=None
	    
return None

