## Script (Python) "cas_quote_consumer_url"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=came_from
##title=prepare came_from URL for CAS transit from login_form
##
from Products.PythonScripts.standard import url_quote

#
# builds a suitable came_from string which can consume POST data
# when coming back to the original page.
# This string (CF) will be encoded differently on each step of its
# transit :
#   - on client side login_form :   html_entities(url_quote(CF))
#   - on CAS server :   service=url_quote(CF)&js_enabed=1& ...
#   - on client side login_success :   html_entities(CF)
#

self = container
request = context.REQUEST
CAS_CONSUME='cas_consume_POST'

if came_from.find('?') > 0:
    CF = "%s&%s=1" % (came_from, CAS_CONSUME)
else:
    CF = "%s?%s=1" % (came_from, CAS_CONSUME)
    
return url_quote(CF)

